#!/usr/bin/env python

"""
Twisted adapter.
"""

import WebStack.Twisted
import twisted.web.resource

class Dispatcher(twisted.web.resource.Resource):

    "A class dispatching requests to WebStack resources."

    isLeaf = 1

    def __init__(self, resource):

        "Initialise the root application-specific 'resource'."

        twisted.web.resource.Resource.__init__(self)
        self.webstack_resource = resource

    def getChild(self, path, request):
        raise NotImplementedError, "getChild"

    def render(self, request):

        "Dispatch the given 'request' to the root application-specific resource."

        trans = WebStack.Twisted.Transaction(request)
        self.webstack_resource.respond(trans)
        trans.commit()
        request.finish()
        return twisted.web.server.NOT_DONE_YET

# vim: tabstop=4 expandtab shiftwidth=4
